/*
	A simple 2D figure rotating

	Fraga 19/11/2000
 */


#include <stdio.h>
#include <GL/glut.h>

float angle=5.0;
int time=1000;  // = 0.5 seg
int timerflag = 1;
float cx; /** Used in resizedWindow function **/

void display(void)
{
	/* clear all pixels  */
	glClear (GL_COLOR_BUFFER_BIT);

	// glMatrixMode(GL_MODELVIEW);

	/* draw a red polygon **/
	glColor3f (1.0, 0.0, 0.0);

	// glPushMatrix( );
	glTranslatef( 0.5, 0.5, 0.0 );	
	glRotatef( angle, 0.0, 0.0, 1.0);
	// glPopMatrix( );

	glBegin(GL_POLYGON);
		glVertex3f (-0.25,-0.25, 0.0);
		glVertex3f (-0.25, 0.25, 0.0);
		glVertex3f ( 0.25, 0.25, 0.0);
	glEnd();
	glTranslatef(-0.5,-0.5, 0.0 );	

	glutSwapBuffers();
}


static void Timer( int val )
{
	// static int i=0;
	// fprintf( stderr, "%d\n", i );
	// i++;

	if ( !val ) return;
	glutTimerFunc( time, Timer, timerflag );
	glutPostRedisplay( );
}

static void
key(unsigned char k, int x, int y)
{
	switch (k) {
		case 27:  /* Escape */
			exit(0);
			break;
		case 'n':
			break;
		case 'f':
			angle = -5.0;
			return;
		case 'b':
			angle =  5.0;
			return;
		case 's':  // stop animation
			timerflag =  0;
			return;
		case 'i':  // start animation
			timerflag =  1;
			glutTimerFunc( time, Timer, timerflag );
			return;
		case '+':  // increase animation elapsed time
			time +=  20;
			return;
		case '-':  // decrease animation elapsed time
			time -=  20;
			if ( time<20 ) time = 20;
			return;
		default:
			return;
	}
	glutPostRedisplay();
}

/**
    w=WindowWidth, h=WindowHeight
**/
void resizedWindow( int w, int h )
{
	float aspect = (float)w/(float)h;

	glViewport (0, 0, w, h );
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	// glOrtho(cx-0.5*aspect, cx+0.5*aspect, 0.0, 1.0, -1.0, 1.0);
	glOrtho( -aspect, aspect, -1.0, 1.0, -1.0, 1.0);
}

void init (void)
{
	/* select clearing color 	*/
	glClearColor (1.0, 1.0, 1.0, 0.0);

	/* initialize viewing values  */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// gluOrtho2D(0.0, 1.0, 0.0, 1.0);
	glOrtho( -1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
	cx = 0.0;
	// If
	//    glOrtho(-1.0, 1.0,-1.0, 1.0, -1.0, 1.0);
	// then
	//    cx = 0.0;
	// and
	//  glOrtho(cx-1.0*aspect, cx+1.0*aspect, 0.0, 1.0, -1.0, 1.0);
	// Ok!!!!!!
}

/*
 * Declare initial window size, position, and display mode
 * (single buffer and RGBA).  Open window with "hello"
 * in its title bar.  Call initialization routines.
 * Register callback function to display graphics.
 * Enter main loop and process events.
 */
int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize (250, 250);
	glutInitWindowPosition (100, 100);
	glutCreateWindow ( argv[0] );
	init ();

	// Initiliazation of callback's functions
	glutDisplayFunc(display);
	glutReshapeFunc(resizedWindow);
	glutKeyboardFunc(key);
	glutTimerFunc( time, Timer, timerflag );

	glutMainLoop();
	return 0;   /* ANSI C requires main to return int. */
}
